#!/usr/bin/perl

# list 4

use strict;
use warnings;

sub greeting {
    my ($name) = @_;  # この変数が封じ込められる

    return sub {
        print "Hello, $name.\n";
    };
}

my $john = greeting("John");
my $tom  = greeting("Tom");

$john->();   # Hello, John.
$tom->();    # Hello, Tom.
